/// @cond EO_CXX_EO_IMPL

inline void elm::slideshow::previous() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_previous());
}

inline ::elm::widget_item elm::slideshow::item_nth_get(unsigned int nth_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_item_nth_get(nth_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slideshow::next() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_next());
}

inline void elm::slideshow::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_clear());
}

inline ::elm::widget_item elm::slideshow::item_add(const Elm_Slideshow_Item_Class * itc_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_item_add(itc_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::slideshow::item_sorted_insert(const Elm_Slideshow_Item_Class * itc_, const void * data_, Eina_Compare_Cb func_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_item_sorted_insert(itc_, data_, func_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline int elm::slideshow::cache_after_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_cache_after_get());
   return _tmp_ret;
}

inline void elm::slideshow::cache_after_set(int count_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_cache_after_set(count_));
}

inline int elm::slideshow::cache_before_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_cache_before_get());
   return _tmp_ret;
}

inline void elm::slideshow::cache_before_set(int count_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_cache_before_set(count_));
}

inline ::efl::eina::string_view elm::slideshow::layout_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_layout_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slideshow::layout_set(::efl::eina::string_view layout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_layout_set(::efl::eolian::to_c(layout_)));
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::slideshow::transition_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_transition_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slideshow::transition_set(::efl::eina::optional< ::efl::eina::string_view > transition_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_transition_set(::efl::eolian::to_c(transition_)));
}

inline bool elm::slideshow::loop_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_loop_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slideshow::loop_set(bool loop_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_loop_set(::efl::eolian::to_c(loop_)));
}

inline double elm::slideshow::timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_timeout_get());
   return _tmp_ret;
}

inline void elm::slideshow::timeout_set(double timeout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_timeout_set(timeout_));
}

inline ::efl::eina::crange_list< ::elm::widget_item > elm::slideshow::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::efl::eina::crange_list< ::efl::eina::string_view > elm::slideshow::transitions_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_transitions_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline unsigned int elm::slideshow::count_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_count_get());
   return _tmp_ret;
}

inline ::elm::widget_item elm::slideshow::item_current_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_item_current_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::efl::eina::string_view > elm::slideshow::layouts_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_layouts_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline void eo_cxx::elm::slideshow::previous() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_previous());
}

inline ::elm::widget_item eo_cxx::elm::slideshow::item_nth_get(unsigned int nth_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_item_nth_get(nth_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slideshow::next() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_next());
}

inline void eo_cxx::elm::slideshow::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_clear());
}

inline ::elm::widget_item eo_cxx::elm::slideshow::item_add(const Elm_Slideshow_Item_Class * itc_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_item_add(itc_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::slideshow::item_sorted_insert(const Elm_Slideshow_Item_Class * itc_, const void * data_, Eina_Compare_Cb func_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_item_sorted_insert(itc_, data_, func_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline int eo_cxx::elm::slideshow::cache_after_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_cache_after_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::slideshow::cache_after_set(int count_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_cache_after_set(count_));
}

inline int eo_cxx::elm::slideshow::cache_before_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_cache_before_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::slideshow::cache_before_set(int count_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_cache_before_set(count_));
}

inline ::efl::eina::string_view eo_cxx::elm::slideshow::layout_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_layout_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slideshow::layout_set(::efl::eina::string_view layout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_layout_set(::efl::eolian::to_c(layout_)));
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::slideshow::transition_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_transition_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slideshow::transition_set(::efl::eina::optional< ::efl::eina::string_view > transition_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_transition_set(::efl::eolian::to_c(transition_)));
}

inline bool eo_cxx::elm::slideshow::loop_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_loop_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slideshow::loop_set(bool loop_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_loop_set(::efl::eolian::to_c(loop_)));
}

inline double eo_cxx::elm::slideshow::timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_timeout_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::slideshow::timeout_set(double timeout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slideshow_timeout_set(timeout_));
}

inline ::efl::eina::crange_list< ::elm::widget_item > eo_cxx::elm::slideshow::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::efl::eina::crange_list< ::efl::eina::string_view > eo_cxx::elm::slideshow::transitions_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_transitions_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline unsigned int eo_cxx::elm::slideshow::count_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_count_get());
   return _tmp_ret;
}

inline ::elm::widget_item eo_cxx::elm::slideshow::item_current_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_item_current_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::efl::eina::string_view > eo_cxx::elm::slideshow::layouts_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slideshow_layouts_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::eo_cxx::elm::slideshow::operator ::elm::slideshow() const
{
   return *static_cast<::elm::slideshow const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::slideshow::operator ::elm::slideshow&()
{
   return *static_cast<::elm::slideshow*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::slideshow::operator ::elm::slideshow const&() const
{
   return *static_cast<::elm::slideshow const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_slideshow_previous_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->previous();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_slideshow_item_nth_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, unsigned int nth_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_nth_get(nth_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slideshow_next_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->next();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_slideshow_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_slideshow_item_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Slideshow_Item_Class * itc_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_add(itc_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_slideshow_item_sorted_insert_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Slideshow_Item_Class * itc_, const void * data_, Eina_Compare_Cb func_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_sorted_insert(itc_, data_, func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
int elm_slideshow_cache_after_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->cache_after_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_slideshow_cache_after_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int count_)
{
   try
      {
         static_cast<T*>(self->this_)->cache_after_set(count_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int elm_slideshow_cache_before_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->cache_before_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_slideshow_cache_before_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int count_)
{
   try
      {
         static_cast<T*>(self->this_)->cache_before_set(count_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::string_view elm_slideshow_layout_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->layout_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slideshow_layout_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * layout_)
{
   try
      {
         static_cast<T*>(self->this_)->layout_set(::efl::eolian::to_cxx<::efl::eina::string_view>(layout_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_slideshow_transition_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->transition_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slideshow_transition_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * transition_)
{
   try
      {
         static_cast<T*>(self->this_)->transition_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(transition_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_slideshow_loop_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->loop_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slideshow_loop_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool loop_)
{
   try
      {
         static_cast<T*>(self->this_)->loop_set(::efl::eolian::to_cxx<bool>(loop_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_slideshow_timeout_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->timeout_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_slideshow_timeout_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double timeout_)
{
   try
      {
         static_cast<T*>(self->this_)->timeout_set(timeout_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::crange_list< ::elm::widget_item > elm_slideshow_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
::efl::eina::crange_list< ::efl::eina::string_view > elm_slideshow_transitions_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->transitions_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
unsigned int elm_slideshow_count_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->count_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         unsigned int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
::elm::widget_item elm_slideshow_item_current_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->item_current_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::crange_list< ::efl::eina::string_view > elm_slideshow_layouts_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->layouts_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::slideshow >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual void previous()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_previous());
      }

      virtual ::elm::widget_item item_nth_get(unsigned int nth_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_item_nth_get(nth_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void next()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_next());
      }

      virtual void clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_clear());
      }

      virtual ::elm::widget_item item_add(const Elm_Slideshow_Item_Class * itc_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_item_add(itc_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_sorted_insert(const Elm_Slideshow_Item_Class * itc_, const void * data_, Eina_Compare_Cb func_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_item_sorted_insert(itc_, data_, func_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual int cache_after_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_cache_after_get());
            return _tmp_ret;
      }

      virtual void cache_after_set(int count_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_cache_after_set(count_));
      }

      virtual int cache_before_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_cache_before_get());
            return _tmp_ret;
      }

      virtual void cache_before_set(int count_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_cache_before_set(count_));
      }

      virtual ::efl::eina::string_view layout_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_layout_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void layout_set(::efl::eina::string_view layout_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_layout_set(::efl::eolian::to_c(layout_)));
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > transition_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_transition_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void transition_set(::efl::eina::optional< ::efl::eina::string_view > transition_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_transition_set(::efl::eolian::to_c(transition_)));
      }

      virtual bool loop_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_loop_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void loop_set(bool loop_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_loop_set(::efl::eolian::to_c(loop_)));
      }

      virtual double timeout_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_timeout_get());
            return _tmp_ret;
      }

      virtual void timeout_set(double timeout_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slideshow_timeout_set(timeout_));
      }

      virtual ::efl::eina::crange_list< ::elm::widget_item > items_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual ::efl::eina::crange_list< ::efl::eina::string_view > transitions_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_transitions_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual unsigned int count_get()
      {
         unsigned int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_count_get());
            return _tmp_ret;
      }

      virtual ::elm::widget_item item_current_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_item_current_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::crange_list< ::efl::eina::string_view > layouts_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slideshow_layouts_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::slideshow >
{
   static constexpr int value = 
#if defined(SLIDESHOW_PROTECTED) && defined(SLIDESHOW_BETA)
      23
#elif defined(SLIDESHOW_PROTECTED)
      23
#elif defined(SLIDESHOW_BETA)
      23
#else
      23
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::slideshow>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_previous_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_previous);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_item_nth_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_item_nth_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_next_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_next);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_item_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_item_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_item_sorted_insert_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_item_sorted_insert);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_cache_after_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_cache_after_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_cache_after_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_cache_after_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_cache_before_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_cache_before_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_cache_before_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_cache_before_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_layout_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_layout_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_layout_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_layout_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_transition_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_transition_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_transition_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_transition_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_loop_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_loop_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_loop_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_loop_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_timeout_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_timeout_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_timeout_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_timeout_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_transitions_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_transitions_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_count_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_count_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_item_current_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_item_current_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slideshow_layouts_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slideshow_layouts_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::slideshow >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::slideshow >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::slideshow>)
{
   return (ELM_SLIDESHOW_CLASS);
}

} } }

/// @endcond

